import React from "react";
import { ReactNode } from "react";
/**
 * Renders children if the client is authenticated.
 *
 * @public
 */
export declare function Authenticated({ children }: {
    children: ReactNode;
}): React.JSX.Element | null;
/**
 * Renders children if the client is using authentication but is not authenticated.
 *
 * @public
 */
export declare function Unauthenticated({ children }: {
    children: ReactNode;
}): React.JSX.Element | null;
/**
 * Renders children if the client isn't using authentication or is in the process
 * of authenticating.
 *
 * @public
 */
export declare function AuthLoading({ children }: {
    children: ReactNode;
}): React.JSX.Element | null;
//# sourceMappingURL=auth_helpers.d.ts.map